<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>PersistantData - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="HttpQuery.html">HttpQuery</a><ul class='methods'><li data-type='method' style='display: none;'><a href="HttpQuery.html#send">send</a></li></ul></li><li><a href="HttpQueryService.html">HttpQueryService</a></li><li><a href="PersistantData.html">PersistantData</a><ul class='methods'><li data-type='method' style='display: none;'><a href="PersistantData.html#loadJSON">loadJSON</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#saveJSON">saveJSON</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#list">list</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#getNewID">getNewID</a></li></ul></li><li><a href="PersistantDataService.html">PersistantDataService</a><ul class='methods'><li data-type='method' style='display: none;'><a href="PersistantDataService.html#~getQuery">getQuery</a></li><li data-type='method' style='display: none;'><a href="PersistantDataService.html#~getNewId">getNewId</a></li></ul></li><li><a href="RemanentForm.html">RemanentForm</a><ul class='methods'><li data-type='method' style='display: none;'><a href="RemanentForm.html#load">load</a></li></ul></li><li><a href="ServerEvent.html">ServerEvent</a><ul class='methods'><li data-type='method' style='display: none;'><a href="ServerEvent.html#onEvent">onEvent</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#isPending">isPending</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#addClock">addClock</a></li></ul></li><li><a href="ServerEventService.html">ServerEventService</a><ul class='methods'><li data-type='method' style='display: none;'><a href="ServerEventService.html#~doQuery">doQuery</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#add">add</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#addClock">addClock</a></li></ul></li><li><a href="StopService.html">StopService</a></li><li><a href="UploadService.html">UploadService</a></li><li><a href="WrapperCC.html">WrapperCC</a><ul class='methods'><li data-type='method' style='display: none;'><a href="WrapperCC.html#call">call</a></li></ul></li><li><a href="WrapperCCService.html">WrapperCCService</a></li><li><a href="cookies.html">cookies</a><ul class='methods'><li data-type='method' style='display: none;'><a href="cookies.html#.get">get</a></li><li data-type='method' style='display: none;'><a href="cookies.html#.set">set</a></li></ul></li><li><a href="slugstring.html">slugstring</a><ul class='methods'><li data-type='method' style='display: none;'><a href="slugstring.html#.fill">fill</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#wrap">wrap</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">PersistantData</h1>
    

    




<section>

<header>
    
        <h2>
        
            PersistantData
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="PersistantData"><span class="type-signature"></span>new PersistantData<span class="signature">(url)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements the interface with a persistent data mechanism.</p>
<ul>
<li>
<p>This is the client side of a simple client/<a href="./PersistantDataService.html">server</a> mechanism.</p>
</li>
<li>
<p>The interface is used in HTML page, using a construct of the form:</p>
</li>
</ul>
<pre class="prettyprint source"><code>&lt;script type='text/javascript' src='.../aideweb.js'>&lt;/script>
&lt;script type='text/javascript'>

 var persistantData = New PersistantData(&quot;http://localhost:8080/_persistantData/upload&quot;);

 // Using, e.g., getNewID
 persistantData.getNewID(true, true, &quot;&quot;, function(value) { 
   console.log(&quot;Testing getNewID: &quot; + value);
 });
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>url</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The service URL.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="loadJSON"><span class="type-signature"></span>loadJSON<span class="signature">(filename, default_value, callback)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Loads a structured value from a given filename.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>filename</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The data file base name without extension.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>default_value</code></td>
            

            <td class="type">
            
                
<span class="param-type">object</span>



            
            </td>

            

            

            <td class="description last"><p>The default value stored into the file if it does not yet exists.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>callback</code></td>
            

            <td class="type">
            
                
<span class="param-type">callback</span>



            
            </td>

            

            

            <td class="description last"><p>The callback that handles the loaded value.</p>
<ul>
<li>Runs the <tt>callback(value: object)</tt> function with the loaded or the default value.</li>
<li>If a syntax error occurs, the value is given as a string.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="saveJSON"><span class="type-signature"></span>saveJSON<span class="signature">(filename, value, backup<span class="signature-attributes">opt</span>, callback)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Saves a structured value in a given filename.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>filename</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The data file base name without extension.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">object</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The value to save as a JSON data structure.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>backup</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>true</code>
                
                </td>
            

            <td class="description last"><p>If true, backup the file, with date.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>callback</code></td>
            

            <td class="type">
            
                
<span class="param-type">callback</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The callback that handles the next action after saving.</p>
<ul>
<li>Runs the <tt>callback()</tt> function after the value is saved.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="list"><span class="type-signature"></span>list<span class="signature">(The, callback)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Lists all data file names, and runs the callback function for each file name.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>The</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>file format.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>callback</code></td>
            

            <td class="type">
            
                
<span class="param-type">callback</span>



            
            </td>

            

            

            <td class="description last"><p>The callback that handles each data file name.</p>
<ul>
<li>Runs the <tt>callback(value: array(string))</tt> function with the loaded or the default value.</li>
<li>The list of the data file base name without extension is given.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="getNewID"><span class="type-signature"></span>getNewID<span class="signature">(when<span class="signature-attributes">opt</span>, where<span class="signature-attributes">opt</span>, suffix<span class="signature-attributes">opt</span>, callback)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns a new ID built from the date in standard format and optionnally the local machine MAC address.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>when</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>true</code>
                
                </td>
            

            <td class="description last"><p>If true, appends the local machine MAC address.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>where</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>true</code>
                
                </td>
            

            <td class="description last"><p>If true, appends the local machine MAC address.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>suffix</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>""</code>
                
                </td>
            

            <td class="description last"><p>If not empty, appends the suffix to the proposed ID.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>callback</code></td>
            

            <td class="type">
            
                
<span class="param-type">callback</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The callback that handles the new ID value.</p>
<ul>
<li>Runs the <tt>callback(value: string)</tt> function with this ID.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>